     /**
     * \brief JSON : Unit Test
   *
   * \author Mihael Schmidt
   * \date   21.01.2011
   */

     H nomain

      *-------------------------------------------------------------------------
      * Prototypes
      *-------------------------------------------------------------------------
     D test_basics...
     D                 PR
     D test_typed_values...
     D                 PR

      /copy RPGUNIT1,TESTCASE
      /copy 'json/json_h.rpgle'
      /copy 'message_h.rpgle'

     P test_basics...
     P                 B                   export
      *
     D json            S               *
   /free
       json = json_create();
       assert(json <> *null : 'Newly created json object mustn''t be null.');
       
       json_putBoolean(json : 'bool' : *on);
       iEqual(json_size(json) : 1);
       assert(json_getBoolean(json : 'bool') = *on :
              'Wrong value for added boolean value.');
       
       json_remove(json : 'bool');
       iEqual(json_size(json) : 0);
       assert(json_isEmpty(json) : 'JSON object should be empty.');
       
       json_putInt(json : 'Integer' : 358);
       iEqual(json_getInt(json : 'Integer') : 358);
       
       json_putString(json : 'String' : 'Mihael');
       aEqual(%str(json_getString(json : 'String')) : 'Mihael');
       
       json_dispose(json);
       
   /end-free
     P                 E

     P test_typed_values...
     P                 B                   export
      *
     D json            S               *
      *
      /free
       json = json_create();
       
       json_putString(json : 'surname' : 'Mihael');
       json_putString(json : 'nickname' : 'Mihael' : 4);
       
       iEqual(2 : json_size(json));
       aEqual('Mihael' : %str(json_getString(json : 'surname')));
       aEqual('Miha' : %str(json_getString(json : 'nickname')));
       
       json_dispose(json);
      /end-free
     P                 E
     